import { world, system, ItemStack, Vector } from '@minecraft/server';

world.afterEvents.playerInteractWithBlock.subscribe(e =>{
	let item = e.itemStack;
	let face = e.blockFace;
	let block = e.block;
	let player = e.player;
	if(item == undefined) return;
	system.run(() =>{
		summonHelchior(item, block, face);
	});
});
var cd = false;
function summonHelchior(i, b, f){
	if(b.typeId != 'raigen:rhyther_skull') return;
	let c01  = b.north().east().typeId == 'raigen:blaze_powder_dust';
	let c02  = b.north().west().typeId == 'raigen:blaze_powder_dust';
	let c03  = b.south().east().typeId == 'raigen:blaze_powder_dust';
	let c04  = b.south().west().typeId == 'raigen:blaze_powder_dust';
	let c05  = b.north().north().east().east().typeId == 'minecraft:redstone_torch';
	let c06  = b.north().north().west().west().typeId == 'minecraft:redstone_torch';
	let c07  = b.south().south().east().east().typeId == 'minecraft:redstone_torch';
	let c08  = b.south().south().west().west().typeId == 'minecraft:redstone_torch';
	let c09  = b.north().north().typeId == 'raigen:blaze_powder_dust';
	let c10 = b.south().south().typeId == 'raigen:blaze_powder_dust';
	let c11 = b.east().east().typeId == 'raigen:blaze_powder_dust';
	let c12 = b.west().west().typeId == 'raigen:blaze_powder_dust';
	let c13 = b.north().north().east().typeId == 'raigen:blaze_powder_dust';
	let c14 = b.north().north().west().typeId == 'raigen:blaze_powder_dust';
	let c15 = b.south().south().east().typeId == 'raigen:blaze_powder_dust';
	let c16 = b.south().south().west().typeId == 'raigen:blaze_powder_dust';
	let c17 = b.east().east().north().typeId == 'raigen:blaze_powder_dust';
	let c18 = b.east().east().south().typeId == 'raigen:blaze_powder_dust';
	let c19 = b.west().west().north().typeId == 'raigen:blaze_powder_dust';
	let c20 = b.west().west().south().typeId == 'raigen:blaze_powder_dust';
	if(c01 && c02 && c03 && c04 && c05 && c06 && c07 && c08 && c09 && c10 && c11 && c12 && c13 && c14 && c15 && c16 && c17 && c18 && c19 && c20){
		if(cd) return;
		cd = true;
		if(i == undefined) return;
		if(i.typeId != 'minecraft:flint_and_steel') return;
		if(f.toLowerCase() != 'up') return;
		switch(b.permutation.getState('raigen:rotation')){
			case 2:
				b.dimension.runCommand(`summon raigen:helchior ${b.x} ${b.y} ${b.z} ~0 ~`);
				break;
			case 3:
				console.warn('3')
				b.dimension.runCommand(`summon raigen:helchior ${b.x} ${b.y} ${b.z} ~90 ~`);
				break;
			case 4:
				console.warn('4')
				b.dimension.runCommand(`summon raigen:helchior ${b.x} ${b.y} ${b.z} ~180 ~`);
				break;
			case 5:
				console.warn('5')
				b.dimension.runCommand(`summon raigen:helchior ${b.x} ${b.y} ${b.z} ~-90 ~`);
				break;
			default:
				break;
		}
		b.dimension.runCommand(`setblock ${b.x} ${b.y} ${b.z} air`);
		cdReset();
	}
}

function cdReset(){
	system.runTimeout(() =>{
		cd = false;
	}, 5);
}